%define ver_major 2.18
%def_disable static
%def_disable docbook

%define _libexecdir /usr/libexec

Name: gnome-screensaver
Version: %ver_major.2
Release: alt0.M40

Summary: GNOME Screensaver
License: GPLv2+
Group: Graphical desktop/GNOME
Url: http://www.gnome.org
Packager: GNOME Maintainers Team <gnome at packages.altlinux.org>

Source0: http://download.gnome.org/sources/gnome-screensaver/%ver_major/%name-%version.tar.bz2
Source1: gnome-screensaver-hide-xscreensaver.menu

Patch0: gnome-screensaver-alt-4.0.patch
Patch1: gnome-screensaver-alt-pam.patch
Patch2: gnome-screensaver-2.18.0-securitytoken.patch
# add support for gnome-keyring to the pam stack
Patch4: gnome-screensaver-2.19-keyring.patch
Patch6: gnome-screensaver-2.20.0-restore-gamma.patch
Patch8: gnome-screensaver-2.20.0-selinux-permit.patch

# From configure.ac

%define dbus_ver 0.30
%define glib_ver 2.7.0
%define GConf_ver 2.6.1
%define gtk_ver 2.7.0
%define gnome_menus_ver 2.11.1
%define libglade_ver 2.5.0
%define libgnomekbd_ver 0.1

PreReq: GConf2 >= %GConf_ver
# since we use it, and pam spams the log if a module is missing
#Requires: pam_gnome-keyring 

BuildPreReq: gnome-common
BuildPreReq: xscreensaver-devel
# From configure.ac
BuildPreReq: intltool >= 0.35
BuildPreReq: libdbus-glib-devel >= %dbus_ver libdbus-devel >= %dbus_ver
BuildPreReq: glib2-devel >= %glib_ver
BuildPreReq: libGConf-devel >= %GConf_ver
BuildPreReq: libgnomeui-devel >= 2.6.0
BuildPreReq: libgtk+2-devel >= %gtk_ver
BuildPreReq: libgnome-menus-devel >= %gnome_menus_ver
BuildPreReq: libglade-devel >= %libglade_ver
#BuildPreReq: libgnomekbd-devel >= %libgnomekbd_ver
BuildPreReq: libpam-devel
BuildPreReq: libnotify-devel
# BuildRequires: libnss-devel
BuildPreReq: xorg-x11-proto-devel libmesa-devel
BuildPreReq: libXxf86misc-devel
BuildPreReq: libXxf86vm-devel
BuildPreReq: libSM-devel libXScrnSaver-devel
%{?_enable_docbook:Requires: xmlto}
BuildRequires: GConf gcc-c++ 

%description
gnome-screensaver is a screen saver and locker that aims to have
simple, sane, secure defaults and be well integrated with the desktop.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
#patch2 -p1 -b .securitytoken
#patch4 -p1 -b .gnome-keyring
%patch6 -p1 -b .restore-gamma
#patch8 -p1 -b .selinux-permit

%build
%autoreconf
%configure  \
	%{subst_enable static} \
	--disable-schemas-install \
	--enable-locking \
	--enable-pam \
	--enable-authentication-scheme=pam \
	--with-pam-prefix=%_sysconfdir \
	--with-xscreensaverdir=%xss_conf_dir \
	--with-xscreensaverhackdir=%xss_hack_dir \
	--with-gdm-config=%_datadir/gdm/defaults.conf \
	--with-libgl \
	--without-shadow \
	--with-kbd-layout-indicator \
%if_enabled docbook
	--enable-docbook-docs \
%endif
	--with-libnotify

%make

%install
#export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make install DESTDIR=%buildroot
#unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL


sed -ie 's|XSL=${DIST_BIN}/xscreensaver-config.xsl|XSL=%_datadir/gnome-screensaver/xscreensaver-config.xsl|' \
        data/migrate-xscreensaver-config.sh
sed -ie 's|b=`basename ${FILE} .xml`|b=xscreensaver-`basename ${FILE} .xml`|' \
        data/migrate-xscreensaver-config.sh

install -m755 data/migrate-xscreensaver-config.sh %buildroot%_libexecdir/gnome-screensaver/gnome-screensaver-migrate-xscreensaver-config.sh
install -m644 data/xscreensaver-config.xsl %buildroot%_datadir/gnome-screensaver/

# hide xscreensaver from the menus
#install -D -m644 %SOURCE1 %buildroot%_sysconfdir/xdg/menus/preferences-post-merged/gnome-screensaver-hide-xscreensaver.menu

%find_lang %name

%post
%update_menus
%gconf2_install %name

%preun
if [ $1 = 0 ]; then
%gconf2_uninstall %name
fi

%postun
%clean_menus

%triggerin -- xscreensaver-hacks xscreensaver-hacks-gl xscreensaver-hacks-rss_glx
(  cd %_datadir/applications/screensavers ; \
  for f in %_datadir/xscreensaver/config/*.xml; do
    %_libexecdir/gnome-screensaver/gnome-screensaver-migrate-xscreensaver-config.sh $f > /dev/null 2>&1
  done)

%triggerun -- xscreensaver-hacks
[ "$2" = 0 ] || exit 0
(cd %_datadir/applications/screensavers; \
for f in $(rpm -ql xscreensaver-hacks | grep '%xss_conf_dir/'); do
  rm -f xscreensaver-$(basename $f .xml).desktop
done)
  
%triggerun -- xscreensaver-hacks-gl
[ "$2" = 0 ] || exit 0
(cd %_datadir/applications/screensavers; \
for f in $(rpm -ql xscreensaver-hacks-gl | grep '%xss_conf_dir/'); do
  rm -f xscreensaver-$(basename $f .xml).desktop
done)
  
%triggerun -- xscreensaver-hacks-rss_glx
[ "$2" = 0 ] || exit 0
(cd %_datadir/applications/screensavers; \
for f in $(rpm -ql xscreensaver-hacks-rss_glx | grep '%xss_conf_dir/'); do
  rm -f xscreensaver-$(basename $f .xml).desktop
done)

%files -f %name.lang
%doc AUTHORS NEWS README COPYING
%config %_sysconfdir/gconf/schemas/*.schemas
#%config %_sysconfdir/xdg/menus/preferences-post-merged/*
%config(noreplace) %_sysconfdir/xdg/menus/gnome-screensavers.menu
%config(noreplace) %_sysconfdir/pam.d/*
%_bindir/*
%_libexecdir/%name
%_libexecdir/gnome-screensaver-gl-helper
%attr(2711,root,chkpwd) %_libexecdir/%name-dialog
%_pkgconfigdir/*
%_desktopdir/gnome-screensaver-preferences.desktop
%_desktopdir/screensavers
%_datadir/gnome-screensaver
%_pixmapsdir/backgrounds/*
%_pixmapsdir/gnome-logo-white.svg
%_datadir/desktop-directories/gnome-screensaver.directory
#_man1dir/*

%changelog
* Sat Jul 26 2008 Alexey Rusakov <ktirf@altlinux.org> 2.18.2-alt0.M40
- backported to the branch 4.0 (had to step back to 2.18.2, since the newer
  ones have too recent buildreqs)
- updated buildreqs according to this version's configure.ac
- sorry, no keyboard layout switcher

* Thu Jul 10 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.2-alt1
- new version 2.22.2

* Mon Mar 31 2008 Alexey Shabalin <shaba@altlinux.ru> 2.22.0-alt1
- initial build for ALTLinux

